package com.dylanvann.fastimage;

import com.bumptech.glide.load.engine.cache.DiskCache;

import java.lang.ref.WeakReference;

public class FastImageDiskCacheFactory implements DiskCache.Factory  {
    private final DiskCache.Factory factory;

    public FastImageDiskCacheFactory(DiskCache.Factory factory) {
        this.factory = factory;
    }

    private static WeakReference<DiskCache> diskCache = null;

    public static DiskCache getDiskCache() {
        return diskCache.get();
    }

    @Override
    public DiskCache build() {
        DiskCache diskCache = factory.build();
        FastImageDiskCacheFactory.diskCache = new WeakReference<>(diskCache);
        return diskCache;
    }
}
